{
  Escreva um procedimento que concatene duas listas encadeadas, formando outra
  lista. (Obs.: As duas listas originais nao precisam ser preservadas.)
}

program ConcatenaListasEncadeadas;
(* Concatena listas encadeadas *)

const
   N = 5;
type
   tApontador = ^no;
   no = record
              palavra : string[20];
              proximo : tApontador;
    	end;
var
   lista1, lista2, lista3, aux1, aux2 : tApontador;
   i : integer;

procedure ConcatenaDuasListasEncadeadas(list1, list2 : tApontador; var list3 : tApontador);
(* Concatena duas listas encadeadas *)

begin
   list3 := list1;    (* A 'lista3' passa a apontar para o inicio da 'lista1' *)

   while (list1^.proximo <> nil) do   (* O ponteiro 'lista1' percorre toda a *)
       list1 := list1^.proximo;       (* lista ate atingir o ultimo noh      *)

   list1^.proximo := list2;  (* Apos chegar no ultimo noh da 'lista1', *)
                             (* este ultimo noh passa a apontar para o *)
                             (* primeiro noh da 'lista2'               *)
end;

begin
	(* Criacao e preenchimento da primeira lista encadeada *)
	writeln('Digite ',N,' palavras (separadas por enter) :');
    new(lista1);
    readln(lista1^.palavra);
    aux2 := lista1;
    for i:=2 to N do begin
    	new(aux1);
        readln(aux1^.palavra);
        aux2^.proximo := aux1;
        aux2 := aux1;
    end;
    aux1^.proximo := nil;   (* Atribuicao de endereco nulo ao ultimo noh da lista *)

    (* Criacao e preenchimento da segunda lista encadeada *)
    writeln('Digite mais ',N,' palavras (separadas por enter) :');
    new(lista2);
    readln(lista2^.palavra);
    aux2 := lista2;
    for i:=2 to N do begin
    	new(aux1);
        readln(aux1^.palavra);
        aux2^.proximo := aux1;
        aux2 := aux1;
    end;
    aux1^.proximo := nil;   (* Atribuicao de endereco nulo ao ultimo noh da lista *)

    (* Concatenacao das listas *)
    new(lista3);
    ConcatenaDuasListasEncadeadas(lista1,lista2,lista3);

    (* Impressao e desalocacao dos nohs *)
    writeln('A frase formada pelas palavras digitadas eh :');
	for i:=1 to 2*N do begin
		write(lista3^.palavra,' ');
        aux1 := lista3;
		lista3 := lista3^.proximo;
        dispose(aux1);
    end;
end.