{
  Escreva um programa que leia uma sequencia de numeros inteiros e imprima o
  segundo maior numero lido.
}

program SegundoMaiorInteiro;
(* Le uma sequencia de numeros inteiros e imprime o segundo maior numero *)

const
   N = 10;
type
   tArranjoInt = array [1..N] of integer;
var
   numeroInteiro : tArranjoInt;
   i, segundoMaiorInteger : integer;

function SegundoMaiorNumeroInteiro(numeroInt : tArranjoInt) : integer;
(* Calcula o segundo maior numero inteiro contido em um arranjo *)

var
   i, maiorInt, segundoMaiorInt: integer;

begin
   (* Calculo do maior numero inteiro *)
   maiorInt := numeroInt[1];
   for i := 2 to N do
       if (maiorInt < numeroInt[i]) then
           maiorInt := numeroInt [i];

   (* Calculo do segundo maior numero inteiro *)
   if (numeroInt[1] <> maiorInt) then     (* Testa se o primeiro elemento do  *)
       segundoMaiorInt := numeroInt[1]    (* arranjo eh o 'maiorInt'; em caso *)
   else                                   (* positivo, nao sera considerado.  *)
       segundoMaiorInt := 0;

   for i := 2 to N do
       if ((segundoMaiorInt < numeroInt[i]) and (numeroInt[i] <> maiorInt)) then
           segundoMaiorInt := numeroInt [i];

   SegundoMaiorNumeroInteiro := segundoMaiorInt;
end;

begin
   (* Leitura dos numeros inteiros *)
   writeln('Digite ',N,' numeros inteiros ( separados por enter) : ');
   for i := 1 to N do
 	   readln(numeroInteiro[i]);

   (* Calculo e impressao do segundo maior numero inteiro digitado *)
   segundoMaiorInteger := SegundoMaiorNumeroInteiro(numeroInteiro);
   writeln('O segundo maior numero inteiro digitado eh : ',segundoMaiorInteger);
end.