{
  Escreva um programa que leia um arquivo do tipo texto e conte todas as
  palavras que contem as vogais A e E ao mesmo tempo.
}

program ContaPalavrasContendoAeE;
(* Le um arquivo do tipo texto e conta o numero de palavras que contem as *)
(* vogais A e E ao mesmo tempo                                            *)

var
   arquivoIn : text;
   i, numPalavras : integer;
   caracter : char;
   contemA, contemE : boolean;

begin
   assign(arquivoIn,'a:\arquivo.txt');   (* Associacao da variavel ao arquivo real *)
   reset(arquivoIn);      (* Preparacao do arquivo para leitura *)

   while not EOF(arquivoIn) do begin
       contemA := false;
       contemE := false;
       while not EOLN(arquivoIn) do begin
           read(arquivoIn,caracter);
           if (caracter <> ' ') then begin
               if ((caracter = 'a') or (caracter = 'A')) then
                   contemA := true;
               if ((caracter = 'e') or (caracter = 'E')) then
                   contemE := true;
		   end
           else begin                                 (* Se o caracter lido eh diferente *)
            	if (contemA and contemE) then         (* de ' ', acabou a palavra        *)
                   numPalavras := numPalavras + 1;
                contemA := false;
                contemE := false;
           end;
       end;

       (* Testa se a ultima palavra da linha contem as vogais *)
       if (contemA and contemE) then
           numPalavras := numPalavras + 1;
       readln(arquivoIn);  (* Pula linha no arquivo de entrada *)
   end;

   close(arquivoIn);   (* Fecha o arquivo *)
   writeln('O numero de palavras que contem, ao mesmo tempo, as vogais "a" e "e" eh : ',numPalavras);
end.