{
  Fazer um programa que:
  a) leia um conjunto de valores inteiros correspondentes a 80 notas de
     alunos de uma turma, notas estas que variam de 0 a 10;
  b) calcule a frequencia absoluta e a frequencia relativa de cada nota;
  c) exiba uma tabela contendo os valores das notas ( de 0 a 10 ) e suas
     respectivas frequencias absoluta e relativa.
}


program FrequenciaAbsolutaEFrequenciaRelativa;
(* Le a nota dos 80 alunos de uma turma e calcula a frequencia absoluta *)
(* e a frequencia relativa de cada nota                                 *)

const
   N = 80;
type
   tArranjoN = array [1..N] of real;
   tArranjoInt = array [1..N] of integer;
var
   notas, freqAbsoluta, freqRelativa : tArranjoN;
   i, j : integer;
   indice : tArranjoInt;
   notaRepetida : boolean;

begin
   for i := 1 to N do begin
       freqAbsoluta[i] := 0;    (* Inicializacao dos elementos dos arranjos *)
       freqRelativa[i] := 0;    (* com zero                                 *)
       indice[i] := 0;
   end;

   (* Leitura das notas *)
   writeln('Introduza as ',N,' notas dos alunos : ');
   for i := 1 to N do
       read(notas[i]);

   (* Calculo da frequencia absoluta *)
   for i := 1 to N do
       for j := 1 to N do
           if (notas[i] = notas[j]) then
               freqAbsoluta[i] := freqAbsoluta[i] + 1;

   (* Calculo da frequencia relativa *)
   for i := 1 to N do
       freqRelativa[i] := freqAbsoluta[i]/N;

   (* Encontra e armazena o indice das notas repetidas *)
   for i := 1 to N do
       for j := 1 to N do
           if ((i <> j) and (notas[i] = notas[j]) and (i <> indice[i])) then
    	       indice[j] := j;

   (* Impressao de uma tabela com as notas e suas respectivas frequencias *)
   (* absoluta e relativa.                                                *)
   writeln('Nota   Freq. Absoluta   Freq. Relativa');
   for i := 1 to N do begin
       notaRepetida := false;
       for j := 1 to N do
    	   if ((i <> j) and (i = indice[i])) then  (* Testa se a nota eh repetida *)
               notaRepetida := true;               (* para nao imprimi-la mais de *)
                                                   (* uma vez                     *)
       if (not notaRepetida) then
           writeln(notas[i]:4:1,'  ',freqAbsoluta[i]:4:1, '  ',freqRelativa[i]:4:3);
   end;
end.