{
  Fazer um programa que :
  a) leia uma matriz A, de dimensao MxN ( M <= 20; N <= 30 ). Os valores de M
     e N sao dados e, a seguir, sao fornecidas as linhas da matriz;
  b) determine a matriz transposta (T) de A;
  c) exiba a matriz A e a sua transposta T.
}

program MatrizTransposta;
(* Le uma matriz e calcula e exibe a sua transposta *)

const
   MAX_M = 20;
   MAX_N = 50;
type
   tArranjo1 = array [1..MAX_M,1..MAX_N] of real;
   tArranjo2 = array [1..MAX_N,1..MAX_M] of real;
var
   A : tArranjo1;
   T : tArranjo2;
   M, N, i, j : integer;

begin
   (* Leitura do numero de linhas da matriz *)
   writeln('Introduza o numero de linhas da matriz :');
   readln(M);
   while (M > MAX_M) do begin   (* Testa se o numero introduzido eh valido *)
       writeln('A matriz admite, no maximo, ',MAX_M,' linhas.');
       writeln('Introduza novamente o numero de linhas da matriz :');
       readln(M);
   end;

   (* Leitura do numero de colunas da matriz *)
   writeln('Introduza o numero de colunas da matriz :');
   readln(N);
   while (N > MAX_N) do begin   (* Testa se o numero introduzido eh valido *)
       writeln('A matriz admite, no maximo, ',MAX_N,' colunas.');
       writeln('Introduza novamente o numero de colunas da matriz :');
       readln(N);
   end;

   (* Leitura dos elementos da matriz *)
   writeln('Introduza os elementos de cada linha da matriz :');
   for i := 1 to M do
       for j := 1 to N do begin      (* Le a matriz linha por linha*)
           read(A[i,j]);
           T[j,i] := A[i,j];
       end;

   (* Imprime a matriz introduzida e sua transposta *)
   writeln('A matriz A eh :');
   for i := 1 to M do begin
       for j := 1 to N do
           write(A[i,j]:9:3);
       writeln;
   end;

   writeln('A matriz transposta de A eh :');
   for i := 1 to N do begin
       for j := 1 to M do
           write(T[i,j]:9:3);
       writeln;
   end;
end.