{
  Fazer um programa que:
  a) leia uma frase de 80 caracteres, incluindo brancos;
  b) conte quantos brancos existem na frase;
  c) conte quantas vezes a letra "A" aparece;
  d) conte quantas vezes ocorre um mesmo par de letras na frase e quais sao
     elas;
  e) exiba o que foi calculado nos itens b, c e d.
}

program AnalisaSequenciaDeCaracteres;
(* Analisa uma sequencia de caracteres, contando quantos espacos em branco   *)
(* exitem, quantas vezes aparece o caracter "A", quantas vezes ocorrem pares *)
(* de letras e quais sao elas                                                *)

const
   MAX = 255;
var
   stringAnalisado : string[MAX];
   i, espacoEmBranco, letraA, numeroDepares : integer;

begin
   espacoEmBranco := 0;
   letraA := 0;           (* Inicializacao das variaveis com 0 *)
   numeroDePares := 0;

   (* Leitura da sequencia de caracteres *)
   writeln('Introduza uma sequencia de caracteres: ');
   read(stringAnalisado);

   (* Leitura da nova sequencia de caracteres *)
   while (length(stringAnalisado) > MAX) do begin
       writeln('Erro. O numero de caracteres eh maior do que ',MAX,'. Introduza-a novamente: ');
       read(stringAnalisado);
   end;

   for i := 1 to (length(stringAnalisado)) do begin
       if (stringAnalisado[i] = ' ') then
           espacoEmBranco := espacoEmBranco + 1; (* Acumula o numero de *)
                                                 (* espacos em branco   *)

       if (stringAnalisado[i] = 'A') then
           letraA := letraA + 1; (* Acumula o numero de vezes que a letra  *)
                                 (* "A" aparece na sequencia de caracteres *)
   end; (* for *)

   for  i := 1 to (length(stringAnalisado) - 1) do

       (* Verifica se um caracter da sequencia eh igual ao seu sucessor *)
       if (stringAnalisado[i] = stringAnalisado[i + 1]) then begin
           numeroDePares := numeroDePares + 1;   (* Acumula o numero de pares *)
           writeln('Ocorre(m) par(es) da letra "',stringAnalisado[i],'" na sequencia de caracteres digitada.');
       end;

       (* Imprime o numero de espacos em branco existentes na sequencia *)
       writeln('Existe ',espacoEmbranco:2,' espaco(s) em branco na sequencia de caracteres digitada.');

       (* Imprime quantas vezes a letra "A" aparece na sequencia *)
       writeln('A letra "A" aparece ',letraA:2,' vez(es) na sequencia de caracteres digitada.');

       (* Imprime o numero de pares existentes na sequencia de caracteres *)
       writeln('Ocorre(m) ',numeroDePares:2,' par(es) de letra(s) na sequencia de caracteres digitada.');
end.


